#!/bin/bash

set -e

release=$1
if [[ "$release" == "" ]]; then
	echo 'usage: checkout.sh stable|acceptance|etc'
	exit 1;
fi

# get project from current dir
project=${PWD##*/}


echo "Looking for curent version of $project-$release.."
version=$(ssh ws2.clusternet "sudo aptitude show -V $project-$release | grep Version")
version=$(echo $version | cut -d ':' -f 2)
echo "Found version: $version"

tag=$(echo $version | sed -e 's/-/_/g')
git fetch --tags
git checkout $tag

