#!/bin/bash

if [ ! -f .babelrc ]; then
    echo 'current dir must be iqportal with a .babelrc file'
    exit 1;
fi

path=$1
if [ -z "$path" ]; then
    path="."
fi

for es6_file in $(find . -name '*.es6'); do

    compiled_file="$(echo $es6_file | sed -e 's/\.es6$/-compiled.js/g')"

    #echo "es6_file: $es6_file"
    #echo "compiled_file: $compiled_file"

    # check newer than
    if [ ! -f "$compiled_file" ] || [ "$es6_file" -nt "$compiled_file" ]; then
        echo "[es6] $(basename $es6_file) -> $(basename $compiled_file)"
        ./node_modules/.bin/babel --out-file $compiled_file $es6_file
    fi


done
