# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

import os
import sys
import commands

import subprocess

from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from os import makedirs

# IQPORTAL_DEV can be set by pycharm for development features
IQPORTAL_DEV = os.environ.has_key('IQPORTAL_DEV') and os.environ['IQPORTAL_DEV']

DEBUG = True

YUI_DEBUG_FILES = True
ES6_COMPILE = True

ADMINS = (('Tek', 'tek@basesoft.com'), )

# base url
BASE_URL = 'http://web:8000/'
DB_CONNSTR = 'mysql://iqportal:bier@mysql:3306/iqportal?charset=utf8'
DB_CONNSTR_READONLY = 'mysql://iqportal_ro:bier_ro@mysql:3306/iqportal?charset=utf8'
DB_CONNSTR_FOODMART = 'mysql://iqportal_ro:bier_ro@mysql:3306/foodmart?charset=utf8'

FONTS_PATH = '/usr/share/fonts'

EMAIL_HOST = None

IQUBE_HOST = 'iqube'
IQUBE_PATH = '/iqube-docker'
#IQUBE_PATH = 'iqube-0.1.0-SNAPSHOT' # enable for iqube debugging
IQUBE_PORT = 8080

MONDRIAN_XMLA_SERVER = (IQUBE_HOST, IQUBE_PORT)
IQUBE_SERVLET = "http://%s:%s/%s/IQubeXmlRpcServlet" % (IQUBE_HOST, IQUBE_PORT, IQUBE_PATH)
MONDRIAN_XMLA_PATH = '/%s/xmla' % (IQUBE_PATH)
MONDRIAN_XMLA_CACHE_ENABLED = not IQPORTAL_DEV

WRITABLE_DIRECTORY = '/home/clients/iqportal/docker'
TMP_FILE_REPOSITORY = os.path.join('/tmp/iqportal/temp')
FILE_REPOSITORY = os.path.join(WRITABLE_DIRECTORY, 'files')
STATIC_SQUASHED_ROOT = os.path.join(WRITABLE_DIRECTORY, 'files')

for dir in (WRITABLE_DIRECTORY, TMP_FILE_REPOSITORY, FILE_REPOSITORY, STATIC_SQUASHED_ROOT):
    if not os.path.exists(dir):
        makedirs(dir)
    assert os.access(dir, os.W_OK)

SYSLOG_IDENT = 'docker'
LOGGER_STDOUT_LEVEL = logging.ERROR
LOGGER_SYSLOG_LEVEL = logging.DEBUG
LOGGER_SYSLOG_ADDRESS = '/dev/log'
SYSLOG_IDENT = 'iqportal-docker'

SELENIUM_DJANGO_ADDR = '0.0.0.0:8000'
SELENIUM['host'] = 'selenium'
SELENIUM['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM['browserURL'] = BASE_URL
SELENIUM['closeBrowser'] = True
SELENIUM['screenshot_path'] = '/tmp/screenshots'

# when IQPORTAL_DEV is set (by pycharm) then its the developer running tests.
# in that kees, keep the browser open and let the dev start its own servers
if IQPORTAL_DEV:
    SELENIUM['closeBrowser'] = False
    SELENIUM['start_django'] = False
    SELENIUM['start_scheduler'] = False

ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL
