# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
Settings for the IQPortal Django project
"""
from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities

DEBUG = True
TEMPLATE_DEBUG = DEBUG

YUI_DEBUG_FILES = True
USE_SOCK_JS = False

BASE_URL = 'http://192.168.8.85:8000/'

#DATABASE_ENGINE = ''           # 'postgresql_psycopg2', 'postgresql', 'mysql', 'sqlite3' or 'oracle'.
#DATABASE_NAME = ''             # Or path to database file if using sqlite3.
#DATABASE_USER = ''             # Not used with sqlite3.
#DATABASE_PASSWORD = ''         # Not used with sqlite3.
#DATABASE_HOST = ''             # Set to empty string for localhost. Not used with sqlite3.
#DATABASE_PORT = ''             # Set to empty string for default. Not used with sqlite3.

#SCHEDULER_TWISTD = '/opt/local/bin/twistd-2.6'

DB_CONNSTR = 'mysql://root:root@localhost:3306/iqportal?charset=utf8'
DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@testorix.dev.ams:3306/foodmart?charset=utf8'
#DB_CONNSTR = 'mysql://root:basesoft@marten.dev.ams:3306/iqportal'
#DB_CONNSTR_FOODMART = 'mysql://foodmart:foodmart@nestorix.office.basesoft.com:3306/foodmart'
#DB_CONNSTR_WEEEBLACKBOX = 'mysql://root:basesoft@127.0.0.1:3306/IQ_ELC_MARTEN_STBL'

DB_CONNSTR_READONLY = DB_CONNSTR

# used for conversion tool testing
#DB_PHP4_IQUEST = {'user': 'root', 'password': 'basesoft', 'host': '127.0.0.1', 'db': 'IS_FMEGTA_EDIT'}

MONDRIAN_XMLA_SERVER = ('localhost', 8080)

mondrian_eclipse = False

if mondrian_eclipse:
    IQUBE_SERVLET = "http://localhost:8080/iqube/IQubeXmlRpcServlet"
    MONDRIAN_XMLA_PATH = '/iqube/xmla'
else:
    IQUBE_SERVLET = "http://localhost:8080/iqube-rado/IQubeXmlRpcServlet"
    MONDRIAN_XMLA_PATH = '/iqube-rado/xmla'

MONDRIAN_XMLA_CACHE_ENABLED = False

#SELENIUM['host'] = '192.168.192.15' #vmware
#SELENIUM['host'] = '192.168.8.72' # testorix
#SELENIUM['browserStartCommand'] = '*firefox'
#SELENIUM['browserStartCommand'] = '*iexplore'
#SELENIUM['browserStartCommand'] = '*chrome'
SELENIUM['desired_capabilities'] = DesiredCapabilities.CHROME
SELENIUM['closeBrowser'] = False
SELENIUM['start_django'] = False
SELENIUM['start_scheduler'] = False

EMAIL_HOST = 'basesoft-fs.office'

TRAC_CONNSTR = 'http://Radostin Radoev:3utrebRu@trac.office.basesoft.com/trac-sandbox/login/xmlrpc'
TRAC_IQPORTAL_VERSION = 'rado'
TRAC_DB_CONNSTR = 'mysql://trac:trac@vm.office:3306/trac_sandbox?charset=utf8'

#SELENIUM['host'] = '192.168.8.152'
#SELENIUM['browserURL']  = 'http://127.0.0.1:8080/'
#SELENIUM['closeBrowser'] = True

#SELENIUM_DJANGO_ADDR = '192.168.8.77:8010'

SERVE_STATIC_MEDIA = True

INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS + TNT_APPS
add_test_apps(INSTALLED_APPS)

STATIC_SQUASHED_ROOT = '/home/rado/static'

# Allow any remote addr to be in admin ips
MIDDLEWARE_CLASSES.append('basesoft.web.middleware.dev.RemoteAddrToInternalIp')
#NODEJS_SERVER = 'http://192.168.8.127:8081'

#WKHTMLTOPDF_BIN = "/Applications/wkhtmltopdf/Contents/MacOS/wkhtmltopdf"

#import os
#if os.uname()[0] == 'Darwin':
FONTS_PATH = None #'/Users/ian/workspace/fonts/'
#LOGGER_SYSLOG_ADDRESS = '/var/run/syslog'

WRITABLE_DIRECTORY = '/home/rado/writable/iqportal/'
IQREPORT_GRAPH_LOCATION = WRITABLE_DIRECTORY
FILE_REPOSITORY = WRITABLE_DIRECTORY
CACHE_DIR = os.path.join(WRITABLE_DIRECTORY, 'cache/')
CONTACT_IMPORT_DIR = os.path.join(WRITABLE_DIRECTORY, 'contacts/')

# careful with this dir as files get deleted after 24h by the scheduler
TMP_FILE_REPOSITORY = '/home/rado/writable/iqportal/temp'

# below is for running the tests from eclipse
if __name__ == '__main__':
    import os
    os.environ['DJANGO_SETTINGS_MODULE'] = 'basesoft.settings.rado'
    from twisted.scripts.trial import run
    import sys
    sys.argv = ['test_bier.py', 'iqportal.iquest.test.selenium.test_iquest_report.IQuestReportTest.test_iquest_report_mdx_functions']
    run()
    sys.exit()