
from sqlalchemy import Table

class IQTable(Table):
    """
    extended sqlalchemy table for iqportal sets the default engine to innodb and utf8
    """

    def __new__(cls, *args, **kw):

        # default table type to mysql_engine
        if not kw.has_key('mysql_engine'):
            kw['mysql_engine'] = 'InnoDB'

        # and utf8
        if not kw.has_key('mysql_charset'):
            kw['mysql_charset']='utf8'

        # super
        return Table.__new__(cls, *args, **kw)




