# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

"""
General purpose functions that can be used for dictionary processing.
"""
from copy import deepcopy

def dict_sum(d1, d2):
    """
    Return a sum of the dictionary elements.

    @param d1: first dictionary
    @param d2: second dictionary
    @return: a new dictionary that holds the unique keys. if d1 and d2 share some keys, the values of d2 will override
        the values from d1
    """

    return dict(d1.items() + d2.items())

def dict_merge(a, b):
    """
    Recursive merge
    """
    if not isinstance(b, dict):
        return b
    result = deepcopy(a)
    for k, v in b.iteritems():
        if k in result and isinstance(result[k], dict):
                result[k] = dict_merge(result[k], v)
        else:
            result[k] = deepcopy(v)
    return result