# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class AccountManagerWidget(DashboardWidgetCQStateController):
    """
    Account Overview Widget
    """
    label = _('Account overview')
    name = 'iq_account_overview_widget'
    #icon = '16x16/categories/applications-accessories.png'
    category = _('Administration')
    permissions = ['view_domain', 'view_license', 'view_all_domains']
    classname = 'palette_group__menu--manager'

    def has_permissions(self, controller):
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('AccountManagerWidget', AccountManagerWidget),
])