# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
URLConf for IQReport user registration.
"""
from django.conf.urls.defaults import url, patterns

from basesoft.web.contrib.account import views

urlpatterns = patterns('',
    # Activation keys get matched by \w+ instead of the more specific
    # [a-fA-F0-9]{8} because a bad activation key should still get to the view;
    # that way it can return a sensible "invalid key" message instead of a
    # confusing 404.

    # please don't change the names of the urls (name='..') cuz they are used
    # in the reverse function
    url(r'^rpc/$', views.rpc),
    url(r'^login/rpc/$', views.login_rpc, name='login_rpc'), # also in LoginDialog from registration_dialog.js
    url(r'^change_password_rpc/$', views.change_password_rpc, name='change_password/rpc'),
    url(r'^manager/rpc/$', views.manager_rpc),
    url(r'^manager/account_validation_rpc/$', views.account_validation_rpc),
    url(r'^registration_form_rpc/$', views.registration_form_rpc),
    url(r'^forgot_password_validation_rpc/$', views.forgot_password_validation_rpc),
    url(r'^forgot_password_form_rpc/$', views.forgot_password_form_rpc),
    url(r'^config_manager/rpc/$', views.config_manager_rpc)
)
