# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext

from basesoft.web.core.models import PrivilegeObject

class Announcement(PrivilegeObject):
    """
    @DynamicAttrs
    """

    STATUS_PENDING = 1
    STATUS_PUBLISHED = 2

    PRIV_RECIPIENT = 32

    _name_property = 'label'

    def get_privileges(self):
        return PrivilegeObject.get_privileges(self) + [
            (self.PRIV_RECIPIENT, ugettext('Receive privileges'))
        ]

    def get_group_object(self):
        return (AnnouncementGroup, 'announcement')

    def __repr__(self):
        return '<Announcement id="%s">' % self.id

class AnnouncementGroup(object):
    """
    @DynamicAttrs
    """


class AnnouncementAccount(object):
    """
    @DynamicAttrs
    """


