# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.models import PrivilegeObject

class BrandingHeaderFooter(PrivilegeObject):
    """
    @DynamicAttrs
    """
    _name_property = 'name'

    def get_group_object(self):
        return (BrandingHeaderFooterGroup, 'header_footer')

    def __repr__(self):
        return '<BrandingHeaderFooter id="%s">' % self.id

class BrandingHeaderFooterGroup(object):
    def __repr__(self):
        return '<BrandingHeaderFooterGroup>'


class Theme(object):
    """
    @DynamicAttrs
    """
    def __repr__(self):
        return '<Theme %s>' % self.name

class LicenseTheme(object):
    """
    @DynamicAttrs
    """
    def __repr__(self):
        return '<LicenseTheme theme=%s license=%s>' % (self.theme.name, self.license.name)


class Site(object):
    """
    @DynamicAttrs
    """
    def __repr__(self):
        return "<Site host_match=%s>" % self.host_match


