# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig

class ContactConfig(DefaultConfig):
    permissions = ['view_contact', 'use_field_mapping_presets']
    label = _('Contact settings')
    is_expanded = False

    def configs(self):
        return [{
            'name': 'contact.import.default.field.mapping.id',
            'label': ugettext('Select default Field Mapping preset'),
            'options': {
                'optionsRpcUrl': 'basesoft.web.contrib.contact.ContactRPCHandler',
                'optionsRpcMethod': 'get_field_mappings',
                'emptyFirstOption': True
            }
        }]

configs = (ContactConfig(), )