# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.contrib.contact.controllers import ContactController
from basesoft.web.contrib.contact.models import ContactList


class ContactRPCHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.account_id = request.session['user_id']
        self.controller = ContactController(self.sa_session, account_id=self.account_id)

    def merge_contact_list_contacts(self, cl1, cl2, unique_identifiers):
        if not isinstance(cl1, ContactList):
            cl1 = self.controller.get_contact_lists(cl1).pop()
        if not isinstance(cl2, ContactList):
            cl2 = self.controller.get_contact_lists(cl2).pop()

        return self.controller.merge_contact_list_contacts(cl1, cl2, unique_identifiers)

    def get_field_mappings(self, id=None):
        return [{'label': fm.name, 'value': fm.id} for fm in self.controller.get_field_mappings(id=id)]

    def get_field_mapping_state(self, id):
        fm = self.controller.get_field_mappings(id=id).pop()
        return self.controller.get_field_mapping_state(fm)

    def save_field_mapping(self, id, values):
        c = ContactController(self.sa_session, account_id=self.account_id)
        c.save_or_update_field_mapping(id, **values)
        return True

handlers = (ContactRPCHandler, )
