# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class TextWidget(DashboardWidgetStateController):
    label = _('Text widget')
    name = 'iq_dashboard_text_widget'
    category = _('Miscellaneous')
    permissions = ['save_dashboard']
    classname = 'palette_compose__menu--edit-text'

    def has_permissions(self, controller):
        return controller.has_any_permissions(*self.permissions)

widgets_mapper = OrderedDict([
    ('TextWidget', TextWidget),
])