# Copyright (c) 2014 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.iconbar.models import IconBarIcon
from basesoft.web.contrib.account.decorators import assert_user_logged_in

class IQPortalDashboardIcon(IconBarIcon):
    """
    Class responsible for handling the home icon
    """

    title = _('Dashboard')
    app = 'dashboard'
    href = "#m=dashboard"
    icon_index = 1 # first icon
    group = 'home'
    group_title = _('Home')
    colorname = 'iconbar-green-coal'

    char_main = u'\uE83f' # Dashboard icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        Home is shown all the time
        """
        controller.assert_permissions('view_dashboard')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """
    return [IQPortalDashboardIcon()]
