# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.models import PrivilegeObject

"""
models for the graph app
"""
class ColorSet(PrivilegeObject):
    """
    This model represents a ColorSet used for chart colors.
    @DynamicAttrs
    """
    _name_property = 'name'

    def get_group_object(self):
        return (ColorSetGroup, 'color_set')

    def __repr__(self):
        return '<ColorSet %s>' % self.name

class ColorSetGroup(object):
    """
    Model representing the link between color sets and groups. Used for privileges.
    @DynamicAttrs
    """
    pass

class GraphTheme(PrivilegeObject):
    """
    @DynamicAttrs
    """
    _name_property = 'name'

    def get_group_object(self):
        return (GraphThemeGroup, 'graph_theme')

    def __repr__(self):
        return '<GraphTheme name=%s>' % self.name

class GraphThemeGroup(object):
    """
    @DynamicAttrs
    """
    pass
