# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.util.db import Session
from django.utils import simplejson as json
from django.template.loader import render_to_string
from django.template import RequestContext
from basesoft.web.contrib.graph.controllers import GraphController
from basesoft.web.core.jsonrpc.dispatcher import JsonRpcJSONEncoder

def js_module_color_sets_env(request):
    """
    This returns some enviroment data we need in a dictionary.
    This is referenced by the iq_report_env module in js_modules
    """

    # colors
    colorsets = {}
    user_id = None
    if request.session.has_key('user_id'):
        user_id = request.session['user_id']
    gc = GraphController(Session(), account_id=user_id, request=request)
    for cs in gc.get_color_sets():
        colors = json.loads(cs.color_config)

        # repeat colors till 1000 so we dont get indexes errors
        for i in range( 1000-len(colors) ):
            colors.append(colors[i % len(colors) ]);

        colorsets[cs.name] = colors
    colorsets = json.dumps(colorsets, ensure_ascii=False, cls=JsonRpcJSONEncoder)

    return render_to_string("graph_env.html", {
        "colorsets": colorsets,
    }, context_instance=RequestContext(request))
