# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from django.conf import settings

from twisted.python.reflect import namedAny

from basesoft.util.ordered_dict import OrderedDict
from basesoft.web.core.util.controllers import AbstractController

loaded_faq = []

for app in settings.INSTALLED_APPS:
    try:
        faq = namedAny(app+'.faq')
    except AttributeError:
        continue
    if not hasattr(faq, 'qas'):
        continue

    loaded_faq += faq.qas


class HelpdeskController(AbstractController):
    def get_faq(self):
        rv = {}
        global loaded_faq

        for faq in loaded_faq:
            if not self.has_permissions(*faq['permissions']):
                continue
            category = unicode(faq['category'])

            if not rv.has_key(category):
                rv[category] = []

            rv[category].append({
                'question': unicode(faq['question']),
                'answer': unicode(faq['answer']),
            })

        k = sorted(rv.keys())
        d = []
        for cat in k:
            d.append((cat, rv[cat], ))

        return OrderedDict(d)