# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.util.ordered_dict import OrderedDict
from basesoft.web.contrib.dashboard.controllers import DashboardWidgetStateController


class FAQWidget(DashboardWidgetStateController):
    """
    Wave Overview Widget
    """
    label = _('FAQ')
    name = 'iq_faq_widget'
    icon = None
    category = _('Miscellaneous')
    permissions = []
    classname = 'palette_group__menu--manager'  # TODO: question mark icon


class IncidentWorkflowWidget(DashboardWidgetStateController):
    """
    Wave Overview Widget
    """
    label = _('Incident workflow')
    name = 'iq_incident_workflow_widget'
    icon = None
    category = _('Helpdesk')
    permissions = ['helpdesk_service']
    classname = 'palette_group__menu--manager'  # TODO: different icon


widgets_mapper = OrderedDict([
    ('FAQWidget', FAQWidget),
    ('IncidentWorkflowWidget', IncidentWorkflowWidget),
])
