'''
Created on Jul 1, 2014

@author: marten
'''
from basesoft.web.contrib.i18n.controllers import I18nController

class I18nRPCHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.user_id = request.session['user_id']
        self.request = request
        self.controller = I18nController(self.sa_session, account_id=self.user_id, request=request)

    def save_domain_country(self, country_id, local_name):
        self.controller.save_domain_country(country_id, local_name=local_name)
        return True

    def toggle_domain_country_active(self, country_id, is_active):
        self.controller.save_domain_country(country_id, active=is_active)
        return True

    def load_domain_language_aliases(self, language_id):
        aliases = self.controller.get_language_aliases_by_language_id(language_id)
        language = self.controller.get_language_by_id(language_id)
        return {
            'name': language.name,
            'iso_639_1': language.iso_639_1,
            'aliases': [{'alias': a.name} for a in aliases]
        }

    def save_domain_language_aliases(self, language_id, values):
        new_aliases = [a['alias'] for a in values['aliases']]
        aliases = self.controller.get_language_aliases_by_language_id(language_id)
        remove = [a for a in aliases if a.name not in new_aliases] # TODO implement

        self.controller.save_domain_language_alias(language_id, *new_aliases)

        if len(remove) > 0:
            self.controller.remove_domain_language_aliases(language_id, *remove)


handlers = (I18nRPCHandler, )
