from basesoft.web.contrib.iconbar.controllers import IconBarController


def iconbar_dyn_scss(request):
    """
    Loaded by js_module 'iconbar_dyn_scss' in js_modules.py. Returns uncompiled SCSS code dynamically based on the icons of the user.

    Can be debugged like:
    http://0.0.0.0:8000/basesoft.web.core/loader_get/trunk/css/i18n_basesoft_web_core,i18n_basesoft_web_contrib_yui,yahoo,dom,event,event-mouseenter,event-delegate,selector,i18n_basesoft_web_contrib_jquery,jquery,jquery_spinner,iq_core,json,connection,iq_broker,get,iq_theme,iq_loader,iqportal_init,element,container,iq_util,iq_container,animation,iq_md5,iq_growl,default_theme_env,basesoft_theme_env,history,button,jquery_corner,jquery_velocity,iq_iconbar,iq_accountconfig,iq_notification,iq_eventlistener,iq_bootloader,iq_boot_register/iconbar_dyn_scss

    """

    parse_str = ""

    account_id = None
    if request.session.has_key('user_id'):
        account_id = request.session['user_id']

    iconbar = IconBarController(request.Session(), account_id=account_id, request=request)

    colors = []

    for icon_group in iconbar.get_icons():
        [colors.append(icon['colorname']) for icon in icon_group if icon['colorname'] not in colors]

    for colorname in colors:
        parse_str += """
        @include setIconBar( $colorname: '%(colorname)s' );
        """ % {
            'colorname': colorname
        }
    return parse_str