'''
Created on Jul 25, 2013

@author: marten
'''
from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig
from basesoft.web.contrib.file.models import ImageFile

class LicenseConfig(DefaultConfig):
    permissions = ('manage_license_company_logo', )
    label = _('Company settings')
    is_expanded = True

    def configs(self):

        options = {}

        if self._controller is not None:
            for img in self._controller.get_privileged_object_by_id(ImageFile, None):
                options[img.id] = img.file_name

        return [{
            'name': 'basesoft.license.company.logo',
            'label': ugettext('Company logo'),
            'options': {
                'options': options
            },
            'help': ugettext('This logo will show up on public locations like surveys and reportings; logos can be uploaded through the File manager.')
        }]


license_configs = {
    'License' : (LicenseConfig(), ),
}
