# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

modules = {
    'iq_license_forms_scss': {
        'type': "scss",
        'path': "license_forms-min.scss"
    },
    'iq_license_forms': {
        'type': "js",
        'path': "license_forms-min.js",
        'requires': ["iq_form_manager", "autocomplete", "iq_license_forms_scss", "iq_fancyselect"]
    },
    'iq_license_wizard': {
        'type': "js",
        'path': "license_wizard-min.js",
        'requires': ["iq_wizard", "iq_license_forms", "iq_person_form",
                    "iq_address_form", "iq_company_form", "iq_bank_account_form"]
    },
    'iq_license_manager': {
        'type': "js",
        'path': "license_manager-min.js",
        'requires': ["iq_manager", "iq_custom_query", "button", "iq_editor_manager", "iq_license_details",
                    "iq_dialog", "iq_license_wizard", "iq_license_manager_css"]
    },
    'iq_license_details': {
        'type': "js",
        'path': "license_details-min.js",
        'requires': ["iq_form_manager", "iq_container", "iq_license_manager_css"]
    },
    'iq_master_data' : {
        'type': "js",
        'path': "master_data-min.js",
        'requires': ["iq_details_panel", 'iq_address_form', 'iq_bank_account_form', 'iq_master_data_css']
    },
    'iq_master_data_css' : {
        'type': "css",
        'path': "master_data-min.css",
    },
    'iq_domain_panel': {
        'type': "js",
        'path': "domain_panel-min.js",
        'requires': ["iq_form_manager", "iq_manager"]
    },
    'iq_license_manager_css': {
        'type': "css",
        'path': "license_manager-min.css"
    },
    'iq_group_manager': {
        'type': "js",
        'path': "group_manager-min.js",
        'requires': ["iq_manager", "iq_custom_query", "iq_form_manager", "iq_fancyselect",
                     "iq_dialog", "iq_group_manager_css"]
    },
    'iq_group_manager_css': {
        'type': "css",
        'path': "group_manager-min.css"
    },

    'iq_hook_manager': {
        'type': "js",
        'path': "hook_manager-min.js",
        'requires': ["iq_manager", "iq_custom_query", "iq_wizard", "iq_form_manager", "iq_fancyselect"]
    },
    'iq_object_browser': {
        'type': "js",
        'path': "object_browser-min.js",
        'requires': ["iq_manager", "iq_custom_query", "treeview", "element", 'iq_object_browser_scss']
    },
   'iq_object_browser_scss': {
        'type': "scss",
        'path': "object_browser-min.scss"
    },
    'iq_permission_overview': {
        'type': "js",
        'path': "permission_overview-min.js",
        'requires': ["iq_manager", "iq_custom_query"]
    },
    'iq_role_manager': {
        'type': "js",
        'path': "role_manager-min.js",
        'requires': ["iq_manager", "iq_custom_query", 'iq_form_manager', 'iq_fancyselect', 'iq_details_panel']
    },
    'iq_privilege_delegation': {
        'type': "js",
        'path': "privilege_delegation-min.js",
        'requires': ['iq_manager', 'iq_custom_query', 'iq_form_manager', 'iq_license_group_select', 'iq_fancyselect']
    },
    'iq_license_group_select': {
        'type': "js",
        'path': "form_group_select-min.js",
        'requires': ["iq_form_manager", "iq_form_core_input", "iq_license_group_select_scss"]
    },
    'iq_license_group_select_scss': {
        'type': "scss",
        'path': "form_group_select-min.scss"
    },
    'iq_privilege_object': {
        'type': "js",
        'path': "privilege_object-min.js",
        'requires': ["iq_broker", "iq_privilege_object_css"]
    },
    'iq_privilege_object_css': {
        'type': "css",
        'path': "privilege_object-min.css"
    },
}
