# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import BaseMailingStateController

class MailingRPCHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.controller = BaseMailingStateController(self.sa_session, account_id=request.session['user_id'])

    def get_available_filters(self):
        return [{'value': avf[0], 'label': avf[1], 'default': avf[0]==0 and True or False}
                for avf in self.controller.get_available_filters()]


handlers = (MailingRPCHandler, )


