# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext as _

from basesoft.web.core.util.custom_query import CustomQuery, CustomQueryModel, CustomQueryField
from basesoft.web.contrib.manual.models import ManualChapter

class ManualChapterCustomQuery(CustomQuery):
    def tables(self):
        return (
            CustomQueryModel(ManualChapter),
        )
    def fields(self):
        return (
            CustomQueryField(ManualChapter.wiki_id, 'id', key='chapter_id'),
            CustomQueryField(ManualChapter.handle, _('Handle'), key='chapter_handle', is_filter=True),
            CustomQueryField(ManualChapter.wiki_id, _('Translate'), key='translate'),
        )

    group_by = (ManualChapter.id, )

custom_queries = (ManualChapterCustomQuery, )
