# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.contrib.account.decorators import login_required
from basesoft.web.contrib.wiki.rpc import AbstractWikiHandler

from basesoft.web.contrib.manual.controllers import ManualController

class ManualRpcHandler(AbstractWikiHandler):
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()
        self.request = request
        self.account_id = None if not request.session.has_key('user_id') else request.session['user_id']

        self._controller = ManualController(self.sa_session, account_id=self.account_id, request=self.request)

    def load_parsed_chapter(self, handle, locale=None):
        return self._controller.load_parsed_chapter(handle, locale)

    def save_manual_chapter(self, _id, forms):
        chapter = self._controller.save_or_update_chapter(_id, forms['manual'], forms['wiki'])
        return _id

    def load_manual_chapter(self, _id):
        return self._controller.load_chapter_state(_id)

    def get_available_languages(self, _id):
        return self._controller.get_available_languages(_id)

    def get_chapter_information(self, _id, locale):
        return self._controller.get_chapter_information(_id, locale)

    def get_history(self, _id, locale):
        return self._controller.get_history(_id, locale)

    def get_what_links_here(self, _id, locale):
        return self._controller.get_links_from(_id, locale)

    def search_wiki(self, _id, locale, terms, match_all=False):
        return self._controller.search_wiki(_id, locale, terms, match_all)

    def search(self, locale, terms, match_all=False):
        return self._controller.search(locale, terms, match_all)

handlers = (ManualRpcHandler, )
