# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.contrib.manual.controllers import ManualController

from django.shortcuts import render_to_response
from django.utils import simplejson
from django.template.context import RequestContext

def print_manual_chapter(request, params):

    wiki = ''
    account_id = request.session['user_id']

    controller = ManualController(request.Session(), account_id=account_id, request=request)

    if params != '':
        params = simplejson.loads(params)

        state = controller.load_parsed_chapter(params['handle'], params['locale'])
        wiki = state['content']

    return render_to_response('view_manual_chapter.html', {
        'wiki': wiki,
        'params': params,
        'title': state['title'],
    }, context_instance=RequestContext(request))