# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.contrib.notification.models import NotificationReminderMail

from django.utils.translation import ugettext as _, ugettext_lazy
from basesoft.web.core.config import DefaultConfig


class NotificationConfig(DefaultConfig):
    permissions = ('view_notification', )
    label = ugettext_lazy('Notification settings')

    def configs(self):
        return [{
            'name': 'basesoft.web.contrib.notification.reminder.mail',
            'label': _('Receive reminder emails about unread notifications'),
            'help': _('To keep you informed of important notifications you might have missed, it is advised to keep this option enabled.'),
            'options': {
                'options': [
                    {'value': NotificationReminderMail.NO_REMINDER, 'label': _('Never')},
                    {'value': NotificationReminderMail.SEND_DAILY, 'label': _('Daily (weekdays only)')},
                    {'value': NotificationReminderMail.SEND_WEEKLY, 'label': _('Once a week')},
                    {'value': NotificationReminderMail.SEND_MONTHLY, 'label': _('Once a month')},
                ]
            }
        }]

configs = (NotificationConfig(), )