# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import MailBaseController
from basesoft.web.contrib.account.mailing import AbstractAccountMailStateController
from basesoft.web.contrib.notification.models import NotificationReminderMail


class NotificationReminderMailStateController(AbstractAccountMailStateController):

    _instance_class = NotificationReminderMail

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['manage_notification_reminder_mail']
    VIEW_ACCESS_PERMISSIONS     = ['manage_notification_reminder_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['manage_notification_reminder_mail']
    DELETE_ACCESS_PERMISSIONS   = ['manage_notification_reminder_mail']
    SCHEDULE_ACCESS_PERMISSIONS = []


class MailController(MailBaseController):
    _state_controllers = {
        'NotificationReminderMail': NotificationReminderMailStateController,
    }