'''
Created on Oct 9, 2013

@author: marten
'''
from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig
from basesoft.web.contrib.order.models import Order

class OrderConfig(DefaultConfig):
    permissions = 'pay_orders'
    label = _('Order and invoice settings')

    def configs(self):
        return [{
            'name': 'basesoft.web.contrib.order.preferred_payment_method',
            'label': ugettext('Preferred payment method'),
            'options': {
                'options': {
                    Order.METHOD_BANK_TRANSFER: ugettext('Bank transfer'),
                    Order.METHOD_DIRECT_DEBIT: ugettext('Direct debit'),
                    Order.METHOD_PSP: ugettext('Online payment'),
                }
            }
        }, {
            'name': 'basesoft.web.contrib.order.receive_invoice_email',
            'label': ugettext('Receive invoice emails'),
        }]

license_configs = {
    'License' : (OrderConfig(), )
}
