'use strict';

var _templateObject = _taggedTemplateLiteral(['\n\t\t\t\t\t<div class="order_date">', '</div>\n\t\t\t\t\t<div class="head">\n\t\t\t\t\t\t<div class="left address">\n\t\t\t\t\t\t\t<strong>', '</strong>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="right address">\n\t\t\t\t\t\t\t<strong>', '</strong>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="clear"></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<table class="lines">\n\t\t\t\t\t\t<thead><tr></tr></thead>\n\t\t\t\t\t\t<tbody></tbody>\n\t\t\t\t\t</table>\n\t\t\t\t'], ['\n\t\t\t\t\t<div class="order_date">', '</div>\n\t\t\t\t\t<div class="head">\n\t\t\t\t\t\t<div class="left address">\n\t\t\t\t\t\t\t<strong>', '</strong>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="right address">\n\t\t\t\t\t\t\t<strong>', '</strong>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t\t<div>', '</div>\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="clear"></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<table class="lines">\n\t\t\t\t\t\t<thead><tr></tr></thead>\n\t\t\t\t\t\t<tbody></tbody>\n\t\t\t\t\t</table>\n\t\t\t\t']),
    _templateObject2 = _taggedTemplateLiteral(['<th>', '</th>'], ['<th>', '</th>']),
    _templateObject3 = _taggedTemplateLiteral(['<td>', '</td>'], ['<td>', '</td>']),
    _templateObject4 = _taggedTemplateLiteral(['\n\t\t\t\t\t\t<td colspan="', '"></td>\n\t\t\t\t\t\t<td>', '</td>\n\t\t\t\t\t\t<td>', '</td>\n\t\t\t\t\t'], ['\n\t\t\t\t\t\t<td colspan="', '"></td>\n\t\t\t\t\t\t<td>', '</td>\n\t\t\t\t\t\t<td>', '</td>\n\t\t\t\t\t']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*
 * Copyright (c) 2015 BaseSoft Solutions B.V.
 * See LICENSE for details.
 */

(function () {
	"use strict";

	BASESOFT.order = BASESOFT.order || {};

	BASESOFT.order.OrderSimulationDetails = function (id, config) {

		config = config || {};
		config.name = config.name || 'order-simulation-details';

		config.brokerUrl = 'basesoft.web.contrib.order.OrderSimulationHandler';
		config.loadMethod = 'load_order_simulation';
		config.saveMethod = 'save_order_simulation';
		config.width = '1100px';

		BASESOFT.order.OrderSimulationDetails.superclass.constructor.call(this, id, config);

		this._orderFields = {};
		this._orderLineFields = {};
	};

	YAHOO.extend(BASESOFT.order.OrderSimulationDetails, BASESOFT.widget.DetailsPanel, {

		_loadOrderFields: function _loadOrderFields(order_type) {

			if (!order_type) throw new Error('invalid order_type');

			if (!this._orderFields[order_type]) {
				this._orderFields[order_type] = $.Deferred();

				this.broker.call('get_order_fields', [order_type], function (result) {
					this._orderFields[order_type].resolve(result);
				}, null, this);
			}
			return this._orderFields[order_type];
		},

		_loadOrderLineFields: function _loadOrderLineFields(order_type, order_line_type) {

			var key = order_type + '-' + order_line_type;

			if (!this._orderLineFields[key]) {
				this._orderLineFields[key] = $.Deferred();

				this.broker.call('get_order_line_fields', [order_type, order_line_type], function (result) {
					this._orderLineFields[key].resolve(result);
				}, null, this);
			}
			return this._orderLineFields[key];
		},

		_createForms: function _createForms() {

			this._formChildren = [new BASESOFT.util.form.Fieldset({
				legend: gettext('Order simulation'),
				children: [new BASESOFT.util.form.Column({ width: '50', children: ['name'] }), new BASESOFT.util.form.Column({ width: '50', children: ['polymorphic_type'] })] })];

			var form = new BASESOFT.util.form.Form({
				validationRpcUrl: this.get('brokerUrl'),
				validationRpcMethod: 'validate_order_simulation',
				layout: new BASESOFT.util.form.Layout({ children: this._formChildren })
			});

			this.form = form;

			this.select_order_type = form.addInput(BASESOFT.util.form.Select, { label: gettext('Order type') }, {
				name: 'polymorphic_type',
				optionsRpcUrl: 'basesoft.web.contrib.order.OrderSimulationHandler',
				optionsRpcMethod: 'get_order_types'
			});
			this.select_order_type.subscribe('valueChange', function (args) {
				this.select_order_type.set('disabled', true);

				var order_type = args.newValue;

				this._loadOrderFields(order_type).done($.proxy(function (order_fields) {
					this._showOrderFields(order_type, order_fields);
				}, this));
			}, null, this);

			if (this._id) {
				this.select_order_type.set('disabled', true);
			}

			form.addInput(BASESOFT.util.form.TextInput, { label: gettext('Name') }, {
				name: 'name'
			});

			form.updateLayout();
			form.appendTo(this.body);

			this._addForm(form);

			return BASESOFT.order.OrderSimulationDetails.superclass._createForms.apply(this, arguments);
		},

		TYPE_TEXT: 1,
		TYPE_BOOLEAN: 2,
		TYPE_INTEGER: 3,
		TYPE_DECIMAL: 4,

		createInput: function createInput(form, field, rpcMethod, rpcArgs) {

			var input;

			switch (parseInt(field.type, 10)) {

				case this.TYPE_TEXT:

					input = form.addInput(BASESOFT.util.form.TextInput, {
						label: field.label
					}, {
						name: field.name
					});

					break;

				case this.TYPE_DECIMAL:

					input = form.addInput(BASESOFT.util.form.DecimalInput, {
						label: field.label
					}, {
						name: field.name
					});

					break;

				case this.TYPE_INTEGER:

					if (field.show_select) {

						var datasource = new BASESOFT.util.JsonRpcDataSource({
							rpcUrl: 'basesoft.web.contrib.order.OrderSimulationHandler',
							rpcMethod: rpcMethod,
							rpcMethodArgs: rpcArgs
						});

						input = form.addInput(BASESOFT.util.form.Combobox2, {
							label: field.label
						}, {
							emptyFirstOption: true,
							name: field.name,
							datasource: datasource
						});

						// when the form changes values, reload all selects
						this.form.on('valuesChange', function (e, select) {

							var rpcArgs = select.get('datasource').getMethodArgs();
							rpcArgs[rpcArgs.length - 1] = this._valuesToState();
							select.get('datasource').setMethodArgs(rpcArgs);
						}, input, this);
					} else {

						input = form.addInput(BASESOFT.util.form.NumberInput, {
							label: field.label
						}, {
							name: field.name
						});
					}

					break;

				case this.TYPE_BOOLEAN:

					input = form.addInput(BASESOFT.util.form.CheckboxInput2, {
						label: field.label
					}, {
						name: field.name
					});

					break;

				default:
					throw new Error('invalid type: ' + field.type);

			}
		},

		_showOrderFields: function _showOrderFields(order_type, order_fields) {

			var order_children = [];

			BASESOFT.util.forEach(order_fields, function (k, field) {
				var input = this.createInput(this.form, field, 'get_order_field_select_options', [order_type, field.name, this._valuesToState()]);
				order_children.push(field.name);
			}, null, this);

			this._lineInput = new BASESOFT.order.SimulationOrderLineInput({
				name: 'line',
				order_type: order_type,
				controller: this
			});

			this._rcc_lines = new BASESOFT.util.form.RowControlContainer({
				name: 'lines',
				additionalRowButtonText: gettext('Add line'),
				inputs: [{
					input: this._lineInput
				}]
			}, {
				name: 'lines' // input name
			});
			this.form.add(this._rcc_lines);

			this._formChildren.push(new BASESOFT.util.form.Fieldset({
				legend: gettext('Order fields'),
				children: order_children,
				expandable: false,
				is_expanded: true
			}), new BASESOFT.util.form.Fieldset({
				legend: gettext('Line fields'),
				children: ['lines'],
				expandable: false,
				is_expanded: true
			}));

			this.form.updateLayout();
		},

		_loadCallback: function _loadCallback(result) {

			this.setHeader(interpolate(gettext('Order simulation information for %(name)s'), {
				'name': result.name
			}, true));

			// while loading, disable form validation
			var rpcUrl = this._forms['default'].get('validationRpcUrl');
			this._forms['default'].set('validationRpcUrl', null);

			// wait for showOrderFields to be completed so that we can fill the lines
			this._loadOrderFields(result['polymorphic_type']).done($.proxy(function (order_fields) {

				BASESOFT.util.forEach(this._rcc_lines.getRowInputs(), function (k, input) {
					input[0].setValues(result.lines[parseInt(k, 10)]);
				}, null, this);
			}, this));
		},

		_validateForms: function _validateForms() {

			var ev2 = new YAHOO.util.CustomEvent();

			var ev = BASESOFT.order.OrderSimulationDetails.superclass._validateForms.apply(this, arguments);

			ev.subscribe(function () {

				var row_inputs = this._rcc_lines.getRowInputs();

				var all = BASESOFT.util.sizeOf(row_inputs);
				var count = 0;

				BASESOFT.util.forEach(row_inputs, function (k, input) {
					input[0].form.validate(function () {
						count++;
						if (count == all) {
							ev2.fire();
						}
					}, null, this);
				}, null, this);
			}, null, this);

			return ev2;
		},

		_valuesToState: function _valuesToState() {
			var form_values = BASESOFT.order.OrderSimulationDetails.superclass._valuesToState.apply(this, arguments);

			if (this._rcc_lines) {
				BASESOFT.util.forEach(this._rcc_lines.getRowInputs(), function (k, input) {
					form_values['lines'][parseInt(k, 10)] = input[0].getValues();
				}, null, this);
			}

			return form_values;
		},

		setFooter: function setFooter() {

			var div_buttons = BASESOFT.order.OrderSimulationDetails.superclass.setFooter.apply(this, arguments);

			var btnSubmit = new YAHOO.widget.Button({
				container: div_buttons,
				label: gettext("Simulate submit")
			});
			btnSubmit.on("click", function (e) {

				this._save(this.POST_SAVE_NO_ACTION, null, e).subscribe(function () {
					new BASESOFT.order.SimulationOrderResult(this._id);
				}, null, this);
			}, null, this);
			this._garbage.push(btnSubmit);
		}

	});

	/**
  * @class BASESOFT.order.SimulationOrderLineInput
  * @extends BASESOFT.util.form.HtmlInput
  * @param attr
  * @constructor
  */
	BASESOFT.order.SimulationOrderLineInput = function (attr) {

		console.warn('SimulationOrderLineInput', attr);

		this._controller = attr.controller;

		BASESOFT.order.SimulationOrderLineInput.superclass.constructor.call(this, attr);

		this._renderForm();
	};
	YAHOO.extend(BASESOFT.order.SimulationOrderLineInput, BASESOFT.util.form.HtmlInput, {

		TYPE_TEXT: 1,
		TYPE_BOOLEAN: 2,
		TYPE_INTEGER: 3,
		TYPE_DECIMAL: 4,

		initAttributes: function initAttributes(attr) {
			BASESOFT.order.SimulationOrderLineInput.superclass.initAttributes.call(this, attr);

			this.setAttributeConfig('order_type', {
				value: attr.order_type
			});
		},

		_createInput: function _createInput() {
			this.input = $('<div></div>').get(0);
		},

		getValues: function getValues() {
			return this.form.getFormValues();
		},

		setValues: function setValues(values) {

			this.form.setFormValues({
				'polymorphic_type': values['polymorphic_type']
			});

			// wait for the rpc to be completed so other fields are available too
			this._controller._loadOrderLineFields(this.get('order_type'), values['polymorphic_type']).done($.proxy(function () {
				this.form.setFormValues(values);
			}, this));
		},

		_renderForm: function _renderForm() {

			var columns = ['polymorphic_type'];

			var order_type = this._controller.form.getInput('polymorphic_type').get('value');

			var form = new BASESOFT.util.form.Form({
				validationRpcUrl: 'basesoft.web.contrib.order.OrderSimulationHandler',
				validationRpcMethod: 'validate_order_simulation_line',
				validationRpcMethodArgs: order_type,
				layout: new BASESOFT.util.form.Layout({
					children: columns
				})
			});

			var line_type_select = form.addInput(BASESOFT.util.form.Select, {
				label: gettext('Order type')
			}, {
				name: 'polymorphic_type',
				emptyFirstOption: true,
				optionsRpcUrl: 'basesoft.web.contrib.order.OrderSimulationHandler',
				optionsRpcMethod: 'get_line_types',
				optionsRpcMethodArgs: [this.get('order_type')]
			});

			line_type_select.subscribe('valueChange', function (args) {

				var order_line_type = args.newValue;

				// set a value on the HtmlInput so that form validation of parent form passes
				this.set('value', order_line_type);

				this._controller._loadOrderLineFields(this.get('order_type'), order_line_type).done($.proxy(function (order_fields) {

					columns.length = 0; // clear array without losing reference
					columns.push('polymorphic_type');

					BASESOFT.util.forEach(order_fields, function (k, field) {

						var input = this._controller.createInput(form, field, 'get_order_line_field_select_options', [this.get('order_type'), order_line_type, field.name, this._controller._valuesToState()]);
						columns.push(field.name);
					}, null, this);

					form.updateLayout();
				}, this));
			}, null, this);

			$(this.input).empty();
			form.appendTo(this.input);
			form.updateLayout();

			// when the rowcontrol form changes values, also notify the parent form
			form.on('valuesChange', function () {
				this._controller.form.fireEvent('valuesChange');
			}, null, this);

			this.form = form;
		}

	});

	/**
  * @class BASESOFT.order.SimulationOrderResult
  * @constructor
  */
	BASESOFT.order.SimulationOrderResult = function (simulation_id) {
		BASESOFT.order.SimulationOrderResult.superclass.constructor.call(this, {
			name: 'order-simulation-result'
		});

		this._simulation_id = simulation_id;
		this._renderOrder();
	};
	YAHOO.extend(BASESOFT.order.SimulationOrderResult, BASESOFT.widget.Panel, {

		_renderOrder: function _renderOrder() {

			var broker = new BASESOFT.util.JsonBroker('basesoft.web.contrib.order.OrderSimulationHandler');

			broker.call('simulate_submit', [this._simulation_id], function (result) {

				var order_result = result.order_result;
				var order_name = result.order_name;

				this.setTitle(interpolate(gettext('Order simulation result for %s'), [order_name]));

				this.body.innerHTML = B.html(_templateObject, order_result.display_date || '', gettext('Billing information'), order_result.client.name, order_result.client.vat_no, order_result.client.address_data.country_name, gettext('Merchant information'), order_result.merchant.name, order_result.merchant.vat_no, order_result.merchant.address_data.country_name);

				// lines can have different attributes
				// loop all of them and prepare a list that can be used to make a table

				// initial list with some kind of order
				var headers = ['polymorphic_type', 'properties', 'description', 'vat_rate', 'price_per_unit', 'quantity', 'gl_account', 'line_amount_excluding_vat', 'line_amount_including_vat'];
				var hide_cols = ['id', 'index', 'polymorphic_type', 'properties', 'line_amount_excluding_vat'];

				// find any additional line fields and append them after 'description' (like 'custom_unit' etc in pvcycle)
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = order_result.lines[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var line = _step.value;

						var keys = Object.keys(order_result.lines[0]);
						var _iteratorNormalCompletion6 = true;
						var _didIteratorError6 = false;
						var _iteratorError6 = undefined;

						try {
							for (var _iterator6 = keys[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
								var key = _step6.value;

								if (!headers.includes(key)) {
									headers.splice(3, 0, key);
								}
							}
						} catch (err) {
							_didIteratorError6 = true;
							_iteratorError6 = err;
						} finally {
							try {
								if (!_iteratorNormalCompletion6 && _iterator6.return) {
									_iterator6.return();
								}
							} finally {
								if (_didIteratorError6) {
									throw _iteratorError6;
								}
							}
						}
					}

					// cache indexes
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}

				var headerIndexes = new Map();
				headers.forEach(function (v, k) {
					headerIndexes.set(v, k);
				});

				// data lines into flat table array
				var data = [];
				var _iteratorNormalCompletion2 = true;
				var _didIteratorError2 = false;
				var _iteratorError2 = undefined;

				try {
					var _loop = function _loop() {
						var line = _step2.value;
						row = [];

						Object.keys(line).forEach(function (k) {
							var field = line[k];
							row[headerIndexes.get(k)] = field;
						});
					};

					for (var _iterator2 = order_result.lines[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
						var row;

						_loop();
					}

					// build table headers
				} catch (err) {
					_didIteratorError2 = true;
					_iteratorError2 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion2 && _iterator2.return) {
							_iterator2.return();
						}
					} finally {
						if (_didIteratorError2) {
							throw _iteratorError2;
						}
					}
				}

				var tr_head = $(this.body).find('table.lines thead tr');
				var _iteratorNormalCompletion3 = true;
				var _didIteratorError3 = false;
				var _iteratorError3 = undefined;

				try {
					var _loop2 = function _loop2() {
						var header = _step3.value;


						if (hide_cols.find(function (element) {
							return element == header;
						})) {
							return 'continue';
						}

						$(tr_head).append($(B.html(_templateObject2, header)));
					};

					for (var _iterator3 = headers[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
						var _ret2 = _loop2();

						if (_ret2 === 'continue') continue;
					}

					// build data lines
				} catch (err) {
					_didIteratorError3 = true;
					_iteratorError3 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion3 && _iterator3.return) {
							_iterator3.return();
						}
					} finally {
						if (_didIteratorError3) {
							throw _iteratorError3;
						}
					}
				}

				var table = $(this.body).find('table.lines tbody');
				var _iteratorNormalCompletion4 = true;
				var _didIteratorError4 = false;
				var _iteratorError4 = undefined;

				try {
					for (var _iterator4 = order_result.lines[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
						var _line = _step4.value;


						var tr = $('<tr></tr>');
						table.append(tr);

						var _iteratorNormalCompletion7 = true;
						var _didIteratorError7 = false;
						var _iteratorError7 = undefined;

						try {
							var _loop3 = function _loop3() {
								var header = _step7.value;


								if (hide_cols.find(function (element) {
									return element == header;
								})) {
									return 'continue';
								}

								var value = _line[header];
								if (value instanceof BASESOFT.util.Decimal) value = value.format(4);

								$(tr).append($(B.html(_templateObject3, value || '')));
							};

							for (var _iterator7 = headers[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
								var _ret3 = _loop3();

								if (_ret3 === 'continue') continue;
							}
						} catch (err) {
							_didIteratorError7 = true;
							_iteratorError7 = err;
						} finally {
							try {
								if (!_iteratorNormalCompletion7 && _iterator7.return) {
									_iterator7.return();
								}
							} finally {
								if (_didIteratorError7) {
									throw _iteratorError7;
								}
							}
						}
					}

					// subtotal, vat, total rows
				} catch (err) {
					_didIteratorError4 = true;
					_iteratorError4 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion4 && _iterator4.return) {
							_iterator4.return();
						}
					} finally {
						if (_didIteratorError4) {
							throw _iteratorError4;
						}
					}
				}

				table.append($('<tr class="spacer"></tr>'));

				var colspan = $(this.body).find('table.lines th').length - 2;

				var totals = [[gettext('Subtotal'), order_result.total_amount_excluding_vat.format(4)], [gettext('VAT'), order_result.total_vat_amount.format(4)], [gettext('Total'), order_result.total_amount_including_vat.format(4)]];

				var _iteratorNormalCompletion5 = true;
				var _didIteratorError5 = false;
				var _iteratorError5 = undefined;

				try {
					for (var _iterator5 = totals[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
						var a_total = _step5.value;


						table.append($('<tr></tr>').html(B.html(_templateObject4, colspan, a_total[0], a_total[1])));
					}
				} catch (err) {
					_didIteratorError5 = true;
					_iteratorError5 = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion5 && _iterator5.return) {
							_iterator5.return();
						}
					} finally {
						if (_didIteratorError5) {
							throw _iteratorError5;
						}
					}
				}
			}, null, this);
		}

	});
})();

YAHOO.register("iq_order_simulation_details", BASESOFT.order.OrderSimulationDetails, {});
