# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
import xmlrpclib

from django.conf import settings
from django.utils.translation import ugettext as _

from basesoft.web.core.exceptions import PublicSystemException
from basesoft.web.core.util.controllers import AbstractController

class SchedulerServerController(AbstractController):

    def system_start_task(self, task, params=None):
        # create a client

        try:
            client = xmlrpclib.Server(settings.SCHEDULER_SERVER_XMLRPC, use_datetime=True, allow_none=True)
        except Exception, e:
            raise PublicSystemException('Unable to connect to scheduler server at %s: %s' % (settings.SCHEDULER_SERVER_XMLRPC, e.message))

        try:
            client.start_task(task, params)
        except xmlrpclib.Fault, e:
            if str(e).find('task is not enabled') > -1:
                self.logger.info("Task[%s] cannot be started as it has not been enabled." % task)
                raise PublicSystemException(_('Unable to start the task as it is not enabled. Please contact the site administrator if this problem persists.'))
            raise
        self.logger.info("Started task[%s]." % task)

    def enable_task(self, task):
        try:
            client = xmlrpclib.Server(settings.SCHEDULER_SERVER_XMLRPC, use_datetime=True, allow_none=True)
        except Exception, e:
            raise PublicSystemException('Unable to connect to scheduler server at %s: %s' % (settings.SCHEDULER_SERVER_XMLRPC, e.message))

        client.enable_task(task)
        self.logger.info("Enabled task[%s]." % task)