# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.exceptions import SecurityException, LoginRequiredException, PublicUserException
from basesoft.web.contrib.account.controllers import AccountController
from basesoft.web.contrib.account.models import Account

from basesoft import logging
from basesoft.web.contrib.soap.soap import set_session_data


def soap_assert_logged_in(*args, **kwargs):
    if kwargs.has_key('context'):
        p = kwargs['context']

        if p.session.has_key('user_id'):
            return True
        raise LoginRequiredException('Login required')

    raise SecurityException('Method does not have a request argument.')

def soap_login(username, password, context):

    logger = logging.getLogger('basesoft.web.contrib.soap', request=context)
    logger.info('login')

    c = AccountController(context.Session())
    account = c.validate_account(username, password)
    if isinstance(account, Account):
        set_session_data(context, account)
        return

    raise PublicUserException('Invalid login')
