'''
Created on May 3, 2013

@author: marten
'''

from django import http
from django.core.handlers.base import BaseHandler
from django.utils import simplejson

from sockjs.tornado import SockJSConnection

from django.conf import settings

from basesoft import logging
from basesoft.web.core.jsonrpc.dispatcher import json_object_hook, JsonRpcResponseException
from basesoft.web.core.util.db import Session
from basesoft.web.core.thread_pool import in_thread_pool
logger = logging.getLogger('basesoft.server')

#from twisted.internet import threads

#import tornado.platform.twisted
#tornado.platform.twisted.install()

class IQPortalHttpRequest(http.HttpRequest):
    def __init__(self, raw_post_data, cookies, *args, **kwargs):
        self._cookie_str = cookies
        http.HttpRequest.__init__(self, *args, **kwargs)
        self._body = raw_post_data
        self._read_started = False

    def _get_cookies(self):
        if not hasattr(self, '_cookies'):
            self._cookies = http.parse_cookie(str(self._cookie_str))
        return self._cookies

    def _set_cookies(self, cookies):
        self._cookies = http.parse_cookie(str(self._cookie_str))

    COOKIES = property(_get_cookies, _set_cookies)

class IQPortalSockJSConnection(SockJSConnection):

    def __init__(self, session):
        self.session = session
        self._base_handler = BaseHandler()
        self._base_handler.load_middleware()

    def on_open(self, info):
        print 'OPENING SOCKET: ', info
        # TODO: store socket in a map for a user for push messages.

    def on_message(self, msg):
        msg = simplejson.loads(msg, object_hook=json_object_hook)
        self._run_in_thread(msg['connid'], *msg['params'])


    @in_thread_pool
    def _run_in_thread(self, connid, location, postdata, cookie, remote_addr=None ):
        #postdata = simplejson.loads(postdata.decode('utf-8'), object_hook=json_object_hook)
        request = IQPortalHttpRequest( postdata.encode('utf-8'), cookie )
        request.Session = Session
        request.path_info = location
        request.META = {'SERVER_NAME': 'localhost', 'SERVER_PORT': settings.IQPORTAL_SERVER_PORT, 'REMOTE_ADDR': remote_addr}

        try:
            response = self._base_handler.get_response(request)
        except Exception, e:
            # log me?
            response = JsonRpcResponseException( request, e )

        if response.status_code != 200:
            return self.send({'connid': connid, 'error': True, 'result': {'faultString': response.content}})

        cookies = {}
        for k, v in response.cookies.items():
            cookies[k] = v.output(header='')
        self.send({'connid': connid, 'result': [response.content, cookies]})

    def on_close(self):
        print 'SOCKET CLOSED'
        # TODO: clear the session socket.

    def on_error(self, *args, **kwargs):
        print 'SOCKET ERROR', args, kwargs





