# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.

"""
This command is used to populate "default" data from the different apps
"""
from twisted.python.reflect import namedAny

from django.core.management.base import BaseCommand
from django.conf import settings

from basesoft.web.core.util.db import Session

from basesoft import logging
from django.utils.translation import get_language
from sqlalchemy.sql.expression import text
logger = logging.getLogger("basesoft.django.commands.iqpopulate")

class Command(BaseCommand):
    """
    """
    help = "Populating default data for the supplied apps"
    args = "[appname...]"

    def handle(self, session=None, *app_names, **options):
        """
        """
        if len(app_names) == 0:
            app_names = settings.INSTALLED_APPS

        session = Session()

        for app in app_names:
            if not app.endswith('.test'):
                continue
            try:
                populate_module = namedAny(app+'.populate')
            except AttributeError:
                continue

            if hasattr(populate_module, 'populate'):
                logger.info('Populating database for app %s' % app)
                populate_module.populate(session)
