# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.
# see django.web.core.util.dependencies for more information

import platform
import twisted
import os

from django.conf import settings

try:
    import migrate # not sure how to check for version
except:
    raise Exception('need dev-python/sqlalchemy-migrate')

# check for required versions
assert platform.python_version().startswith('2.6') or platform.python_version().startswith('2.7'), "Need python 2.6 or 2.7 Current version is %s" % platform.python_version()
assert twisted.__version__.startswith('11.'), "Need twisted 11.x. Current version is %s" % twisted.__version__

# check for writable dirs
dirs = [settings.WRITABLE_DIRECTORY]
for path in dirs:
    if not (os.path.exists(path) and os.path.isdir(path)):
        raise Exception("Writable dir %s doesn't exist" % path)

    if not os.access(path, os.W_OK):
        raise Exception("Writable dir %s doesn't allow write access" % path)

try:
    import pyPdf
except:
    raise Exception('need dev-python/pyPdf')


if not os.path.exists(settings.WKHTMLTOPDF_BIN):
    raise Exception('need media-gfx/wkhtmltopdf-bin')

