# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from django.conf.urls.defaults import patterns, url
from basesoft.web.core import views
from basesoft.web.core.rte import views as views_rte

version_regex = '([\w|\d|_|\-|\.]+)'

urlpatterns = patterns ('',

    url(r'^blank/$', views.blank),

    # bootstrap urls accept extra modules in the form: /bootstrap/js/editor+tabview
    url(r'^bootstrap/%s/(\w+)/([\w|\,\-]*)$' % version_regex, views.bootstrap),
    url(r'^loader_get/%s/(\w+)/([\w|_|\,\-]*)/([\w|_|\,\-]+)+/?\d*' % version_regex, views.loader_get),

    # RTE editor replacement fields image renderor
    url(r'rte/make_image/(.+)', views_rte.make_image),

    # custom query
    url(r'^custom_query/([\.\w]+)/', views.custom_query),
    url(r'^rpc/([\.\w]+)/', views.rpc),

    url(r'objects/rpc/$', views.objects_rpc),

    url(r'^download/([a-z0-9]{8}).*$', views.download_xls),

    url(r'^download_pdf/(.*)$', views.download_pdf),

    url(r'^download_screenshot/(.*)$', views.download_screenshot),
)


