# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class IQPortalMockupComposeIcon(IconBarIcon):
    """
    Class responsible for handling the form icon
    """

    id = 'icon-mockup-compose'
    title = _('Mockup designer')
    app = 'mockup_compose'
    icon_index = 19
    group = 'dev_compose'
    colorname = 'iconbar-bay-leaf'

    char_main = u'\uE810' # Stencil icon
    char_sub = u'\uE811' # Pencil icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        """
        controller.assert_permissions('develop_tools')

class IQPortalMockupOverviewIcon(IconBarIcon):
    """
    Class responsible for handling the form overview icon
    """

    id = 'icon-mockup-overview'
    title = _('Mockups overview')
    component = 'iq_mockup_overview'
    icon_index = 20
    group = 'dev_compose'
    colorname = 'iconbar-bay-leaf'

    char_main = u'\uE810' # Stencil icon
    char_sub = u'\uE810' # Stencil icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        """
        controller.assert_permissions('develop_tools')

def get_icons():
    """
    return the list of icons that the home app adds to the iconbar
    """
    return []
