# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class DevPHP4ImportResponses(IconBarIcon):
    """
    Class responsible for handling the conversion icon
    """

    id = 'icon-dev-php4-iquest-responses-import'
    title = _('IQuest PHP Response Import')
    component = 'iq_dev_php4_iquest_import_wizard'
    icon_index = 21
    group = 'dev_compose'
    colorname = 'iconbar-bay-leaf'

    char_main = u'\uE814' # Repeat icon

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        """
        controller.assert_permissions('php4_response_import', 'create_survey_publication')

def get_icons():
    """
    return the list of icons that the dev.util app adds to the iconbar
    """
    return []
