"this is the locale selecting middleware that will look at accept headers"

from django.conf import settings

from django.utils.cache import patch_vary_headers
from django.utils import translation

from basesoft.web.core.util.controllers import AccountConfigController


class LocaleMiddleware(object):

    def process_request(self, request):
        """
        """

        # locale is like en_GB, nl_NL
        locale = None

        # check if the user is logged in and if he has a account config locale set,
        # then take that locale
        if request.session.has_key('user_id'):
            ac = AccountConfigController(request.Session(), request.session['user_id'])
            ac_locale = ac.get('basesoft.web.contrib.locale')

            if ac_locale != '':
                locale = ac_locale

        # not logged in: try to get locale from session
        else:
            locale = request.session.get('django_language', None)

        # TODO: check for browser language

        # if no lang is found, fallback to english
        if locale is None:
            locale = 'en_GB'
            request.session['django_language'] = locale

        translation.activate(locale)
        request.LANGUAGE_CODE = locale
