# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

"""
Middleware used for getting the default country of the visitor
"""

class DefaultLocation(object):
    """
    Middleware for adding the detecting the probably country as the default country of the user.

    Needs to be added to the MIDDLEWARE_CLASSES list after the session middlewar.
    """
    def process_request(self, request):
        """
        Check the default_country from the session, and if it's not there, try to set it.
        If the country can't be detected, set the default_country as 'NL'
        """
        default_country_code = None
        try:
            default_country_code = request.session['default_country_code']
        except KeyError:
            return
        
            import GeoIP
            gi = GeoIP.new(GeoIP.GEOIP_MEMORY_CACHE)
            ip = request.META['REMOTE_ADDR']
            default_country_code = gi.country_code_by_addr(ip)
            if default_country_code == None:
                default_country_code = 'NL'
            request.session['default_country_code'] = default_country_code
