'''
Created on 9 Feb 2011

@author: martijn
'''

import hotshot
import os
import time

from django.conf import settings

PROFILE_DATA_DIR = "/tmp/iqportal_profile"


class ProfileMiddleware(object):

    def process_request(self, request):

        if not settings.PROFILING:
            return

        path = getattr(settings, 'PROFILE_DIR', PROFILE_DATA_DIR)
        if not os.path.exists(path):
            os.makedirs(path)
            os.chmod(path, 0755)

        profname = request.path.strip("/").replace('/', '.')
        profname = "%s_%s.prof"  % (profname[:80], time.time())

        profname = os.path.join(PROFILE_DATA_DIR, profname)
        self.prof = hotshot.Profile(profname)

    def process_view(self, request, callback, callback_args, callback_kwargs):

        if settings.PROFILING:
            return self.prof.runcall(callback, request, *callback_args, **callback_kwargs)

    def process_response(self, request, response):

        if settings.PROFILING:
            self.prof.close()

        return response

