'''
Created on Nov 20, 2013

@author: marten
'''
from django.utils.translation import ugettext as _

from basesoft.web.contrib.contact.models import Company, Person, Contact

class ArvatoCompany(Company):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('Arvato Company')
    STR = 'ArvatoCompany'
    JS_MODULE = 'iq_company_form'

    def __repr__(self):
        return '<ArvatoCompany company_id=%s>' % self.id

class ArvatoPerson(Person):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('Arvato Person')
    STR = 'ArvatoPerson'
    JS_MODULE = 'iq_person_form'

    def __repr__(self):
        return '<ArvatoPerson person_id=%s>' % self.id

class ArvatoContact(Contact):
    """
    @DynamicAttrs
    """
    NAME_I18N = _('Arvato Contact')
    PERMISSIONS = ('arvato_contact_access', )
    STR = 'ArvatoContact'

    person_instance_class = ArvatoPerson
    company_instance_class = ArvatoCompany

    cols_i18n = dict(Contact.cols_i18n.items() + {
        "case_id": _("Case ID"),
        "case_created": _("Case created"),
        "case_created_team": _("Case created team"),
        "case_status": _("Case status"),
        "complaint": _("Complaint"),
        "channel": _("Channel"),
    }.items())

    def __repr__(self):
        return '<ArvatoContact contact_id=%s>' % self.contact_id

