# Copyright (c) 2012 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy.orm.exc import NoResultFound

from basesoft.web.contrib.license.models import Domain
from basesoft.web.contrib.i18n.models import DomainCountry, Country

synced_apps = []  # global used to see what apps have already been synced until now


def sync(session):

    try:
        fme_domain = session.query(Domain).filter(Domain.name == 'FME').one()
        sync_fme_domain_countries(session, fme_domain)
    except NoResultFound:
        print 'no FME domain, skip syncing..'


def sync_fme_domain_countries(session, fme_domain):

    countries = {
        'NL': 'Nederland',
        'BE': 'Belgie'
    }

    for country_code, domain_country_name in countries.iteritems():
        try:
            session.query(DomainCountry) \
                .join(Country) \
                .filter(DomainCountry.domain == fme_domain) \
                .filter(Country.iso_3166_a2 == country_code).one()
        except NoResultFound:
            dc = DomainCountry()
            dc.domain = fme_domain
            dc.name = domain_country_name
            dc.country = session.query(Country).filter(Country.iso_3166_a2 == country_code).one()
            dc.active = True
            session.add(dc)

    # and its gone
    session.flush()