# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class DashboardCalendarWidget(DashboardWidgetStateController):
    """
    Simple unusable calendar widget for demo purposes only.
    """
    label = _('Calendar')
    name = 'iq_calendar_widget'
    icon = '16x16/apps/office-calendar.png'
    unicode_icon = u'\uE806'


class BreakdownStatisticalPeriod(DashboardWidgetStateController):
    """
    Demo purposes
    """
    label = "Statistical Breakdown"
    name = "demo_statistical_period"
    icon = '16x16/mimetypes/x-office-drawing.png'
    category = 'Demo'

class BreakdownInvoicedPeriod(DashboardWidgetStateController):
    """
    Demo purposes
    """
    label = "Invoiced Breakdown"
    name = "demo_invoiced_period"
    icon = '16x16/mimetypes/x-office-presentation.png'
    category = 'Demo'

class AlertWidget(DashboardWidgetStateController):
    """
    Demo purposes
    """
    label = "Alerts"
    name = "demo_alert_widget"
    icon = '16x16/emblems/emblem-important.png'
    category = 'Demo'

class ManagementReportWidget(DashboardWidgetStateController):
    """
    A management report for demo purposes, that shows some tables and some graphs.
    """
    label = 'Management report'
    name = 'iq_management_report_widget'
    icon = '16x16/mimetypes/x-office-spreadsheet.png'
    category = 'Demo'

# for the helpdesk demo we only want to show the calendar from here
widgets_mapper = OrderedDict([
                 ('DashboardCalendarWidget', DashboardCalendarWidget)
                 ])