# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.mobile.models import MobileIcon

class MobileDemoIcon(MobileIcon):
    """
    """

    title = _('Demo')
    desc = _('Examples of IQPortal Mobile capabilities for demonstration purposes')
    image = '/site_media/basesoft.web.contrib.basesoft/75x75/apps/preferences-desktop-wallpaper.png'
    icon_index = 1
    name = 'mobile-demo'

    js_module = 'mobile_app_demo'

    #@assert_user_logged_in
    def has_permissions(self, controller):
        """
        this is shown only if the permissions are met
        """
        return True

def get_icons():
    return [MobileDemoIcon()]