# Copyright (c) 2012 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.mailing.controllers import MailBaseController, AbstractMailStateController
from iqportal.iqreport.core.models import IQReportMail

class IQReportMailStateController(AbstractMailStateController):
    """
    Takes care of the IQReportMail states
    """
    _instance_class = IQReportMail

    # permissions needed for using this kind of mail
    CREATE_ACCESS_PERMISSIONS   = ['create_iqreport_mail']
    VIEW_ACCESS_PERMISSIONS     = ['view_iqreport_mail']
    UPDATE_ACCESS_PERMISSIONS   = ['update_iqreport_mail']
    DELETE_ACCESS_PERMISSIONS   = ['delete_iqreport_mail']
    SCHEDULE_ACCESS_PERMISSIONS = ['schedule_iqreport_mail']

class MailController(MailBaseController):
    """
    Class that's on top of the MailBaseController. This is used for
    handling IQReportMail objects.
    """
    # mapping between object type and the controller
    _state_controllers = {
        'IQReportMail': IQReportMailStateController,
    }
