'''
Created on Sep 16, 2014

@author: marten
'''
from django.utils.translation import ugettext as _

from basesoft.web.core.util.custom_query import CustomQuery, CustomQueryModel, CustomQueryField

from iqportal.iqube.compose.models import MdxFormatString

class MdxFormatStringCustomQuery(CustomQuery):
    permissions = ('manage_format_strings',)

    def tables(self):
        return (
            CustomQueryModel(MdxFormatString),
        )

    def fields(self):
        return (
            CustomQueryField(MdxFormatString.id, _('ID'), key="id"),
            CustomQueryField(MdxFormatString.name, _('Name'), key="name", is_filter=True),
            CustomQueryField(MdxFormatString.format_string, _('Format string'), key='format_string'),
        )

custom_queries = (
    MdxFormatStringCustomQuery,
)
