'''
Created on Feb 19, 2014

@author: martijn
'''

from django.conf import settings
from twisted.python.reflect import namedAny

def post_process(conn):

    projects = []
    app_names = settings.INSTALLED_APPS
    for app in app_names:

        try:
            sync_module = namedAny(app+'.iqube_sync')
        except AttributeError:
            continue

        if not hasattr(sync_module, 'projects'):
            continue

        for project in sync_module.projects:
            projects.append(project.project_name)

    for p in projects:
        s = '%s.%s' % (settings.SETTINGS_MODULE, p)
        conn.execute("update tblDataSource set name = %s, mondrian_project=%s where name like %s;",  (s, s, 'basesoft.settings.%%%%.%s' % p) )
