# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iqube.core import views


modules = {

    'iqube_env': {
        'type': 'js',
        'path': views.js_module_iqube_env,
    },

    'iqube_core': {
        'type': 'js',
        'path': 'core-min.js'
    },

    'iqube_mdx_formula_wizard': {
        'type': 'js',
        'path': 'mdx_formula_wizard-min.js',
        'requires': ['iq_container', 'iq_manager', 'iq_wizard', 'iqube_mdx_compose_env']
    },

    'iqube_datasource_manager': {
        'type': "js",
        'path': "datasource_manager-min.js",
        'requires': ['iq_container', 'iq_custom_query', 'iq_manager']
    },

    'iqube_datasource_panel': {
        'type': "js",
        'path': "datasource_panel-min.js",
        'requires': ['iq_container', 'iq_form_manager']
    },

    'iqube_datasource_objects_panel': {
        'type': "js",
        'path': "datasource_objects_panel-min.js",
        'requires': ['iq_container', 'iq_form_manager']
    },

    'iqube_cube_table': {
        'type': "js",
        'path': "cube_table-min.js",
        'requires': ['iqube_core', 'element', 'iqube_cube_table_scss', 'iq_form_manager', 'iqube_formatters']
    },

    'iqube_cube_table_scss': {
        'type': "scss",
        'path': "cube_table-min.scss"
    },

    'iqube_member_tree': {
        'type': "js",
        'path': "member_tree-min.js",
        'requires': ["treeview", "element"]
    },

    'iqube_cube_manager': {
        'type': "js",
        'path': "cube_manager-min.js"
    },

    'iqube_cube_designer': {
        'type': "js",
        'path': "cube_designer-min.js",
        'requires': ['iqube_cube_designer_css', 'iq_form_manager', 'dragdrop', 'iqube_env'],
    },

    'iqube_cube_designer_css': {
        'type': "css",
        'path': "cube_designer-min.css",
    },

   'iqube_mdx_calculated_member_manager': {
        'type': 'js',
        'path': 'mdx_calculated_member_manager-min.js',
        'requires': ['iq_custom_query', "iq_manager"]
    },

    'iqube_configurable_widget_manager': {
        'type': 'js',
        'path': 'configurable_widget_manager-min.js',
        'requires': ['iq_container', 'iq_custom_query', "iq_manager",]
    },

    'iqube_configurable_widget_wizard': {
        'type': "js",
        'path': "configurable_widget_wizard-min.js",
        'requires': ["iq_wizard", "iqube_configurable_widget"]
    },

    'iqube_configurable_widget': {
        'type': "js",
        'path': "configurable_widget-min.js",
        'requires': ['iqube_core', "iqube_configurable_widget_scss", "iq_form_manager", "level_filter_fancy_select",
                     "iq_container", 'iqreport_fusioncharts_properties', 'iqube_mdx_syntax_highlight']
    },

    'iqube_configurable_widget_scss': {
        'type': "scss",
        'path': "configurable_widget-min.scss"
    },

    'configurable_report_item': {
        'type': "js",
        'path': "configurable_report_item-min.js",
        'requires': ["iqreport_canvas_item", "abstract_configurable_compose_item", "configurable_report_item_css",]
    },

    'configurable_report_item_css': {
        'type': "css",
        'path': "configurable_report_item-min.css",
    },

    'abstract_configurable_compose_item': {
        'type': 'js',
        'path': 'abstract_configurable_compose_item-min.js',
        'requires': ['iqube_core', 'bs_graph', 'iqreport_mdx_result', 'iq_compose']
    },

    'iqube_db_configurable_widget': {
        'type': "js",
        'path': "db_configurable_widget-min.js",
        'requires': ["abstract_configurable_compose_item"]
    },

    'level_filter_fancy_select': {
        'type': "js",
        'path': "level_filter_fancy_select-min.js",
        'requires': ["iq_fancyselect"]
    },

    'iqube_formatters': {
        'type': 'js',
        'path': 'formatters-min.js',
    },

    # pivottable
    'iqube_pivottable': {
        'type': 'js',
        'path': 'pivottable-min.js',
        'requires': ['iqube_pivottable_css', 'dragdrop', 'iqube_cube_table', 'bs_wireit']
    },

    'iqube_pivottable_css': {
        'type': 'css',
        'path': 'pivottable-min.css'
    },

    'xmla_init': {
        'type': 'js',
        'path': 'xmla_init.js',
        'requires': ['xmla_test']
    },

    'xmla_test': {
        'type': 'js',
        'path': 'xmla_test.js',
        'requires': ['iq_form_manager', 'iqube_cube_table', 'button']
    },

    'iqube_datasource_cube_panel': {
        'type': 'js',
        'path': 'datasource_cube_panel-min.js',
        'requires': ['iq_form_manager', 'iq_container', 'iqube_datasource_cube_panel_scss']
    },

    'iqube_datasource_cube_panel_scss': {
        'type': 'scss',
        'path': 'datasource_cube_panel-min.scss',
        'requires': ['iq_buttons_scss']
    },

    'iqube_mdx_calculated_member' : {
        'type': "js",
        'path': "mdx_calculated_member-min.js",
        'requires': [],
    },

    'iqube_mdx_set_form' : {
        'type': "js",
        'path': "mdx_set_form-min.js",
        'requires': ['iq_form_manager', 'level_filter_fancy_select']
    },

    'iqube_mdx_measure_form' : {
        'type': "js",
        'path': "mdx_measure_form-min.js",
        'requires': ['iq_form_manager']
    },

    'iqube_mdx_member_form' : {
        'type': "js",
        'path': "mdx_member_form-min.js",
        'requires': ['iq_form_manager', 'level_filter_fancy_select']
    },

   'iqube_mdx_time_member_form' : {
        'type': "js",
        'path': "mdx_member_form-min.js",
        'requires': ['iq_form_manager', 'level_filter_fancy_select']
    },

    'iqube_mdx_level_form' : {
        'type': "js",
        'path': "mdx_level_form-min.js",
        'requires': ['iq_form_manager']
    },

    'iqube_mdx_time_level_form' : {
        'type': "js",
        'path': "mdx_level_form-min.js",
        'requires': ['iq_form_manager']
    },

    'iqube_mdx_syntax_highlight' : {
        'type': "js",
        'path': 'mdx_syntax_highlight-min.js',
        'requires': ['iqube_mdx_syntax_highlight_scss']
    },

    'iqube_mdx_syntax_highlight_scss' : {
        'type': "scss",
        'path': 'mdx_syntax_highlight-min.scss',
    },

}
