/*
 * Copyright (c) 2012 BaseSoft B.V.
 * See LICENSE for details.
 */

// namespace
if (typeof BASESOFT.xmla == 'undefined')
	BASESOFT.xmla = {};

(function(){

	BASESOFT.xmla.Test = function (container) {

		this.container = container || document.createElement('div');

		this.broker = new BASESOFT.util.JsonBroker('iqportal.iqube.core.IQubeRPCHandler', {executeIfLoggedOut: true});


	};

	BASESOFT.xmla.Test.prototype = {

		render: function () {

			var form = new BASESOFT.util.form.Form({

				layout: new BASESOFT.util.form.Layout({

					children: ['datasource', 'mdx', 'render_table']

				})

			});

			form.addInput(BASESOFT.util.form.TextInput, {
				label: 'Datasource'
			}, {
				name: 'datasource',
				value: 'basesoft.settings.'
			});

			form.addInput(BASESOFT.util.form.TextAreaInput, {
				label: 'MDX'
			}, {
				name: 'mdx',
				rows: 10,
				cols: 80
			});

			form.addInput(BASESOFT.util.form.CheckboxInput, {
				label: 'Render Table'
			}, {
				name: 'render_table',
				checked: 'checked'
			});

			form.updateLayout();
			form.appendTo(this.container);

			var b = new YAHOO.widget.Button({
				container: form.get('element'),
				label: gettext("Get XMLA result")
			});

			this.resultC = document.createElement('div');
			this.container.appendChild(this.resultC);

			this.resultC.innerHTML = '';

			b.on("click", function(e){

				var values = form.getFormValues();
				
				this.resultC.innerHTML = '';

				this.broker.call('get_raw_result', [values.datasource, values.mdx, values.render_table], function (result) {
					var xmla = result[0];
					var tableData = result[1];
					if (tableData) {

						var ct = new BASESOFT.iqube.CubeTable(this.resultC, tableData);

					}
					var ta = document.createElement('textarea');
					ta.rows = 20;
					ta.cols = 60;
					ta.value = xmla;
					this.resultC.appendChild(ta);
				}, function(e) {
					this.resultC.innerHTML = e;

				}, this);

			}, null, this);

		}

	};


})();

YAHOO.register("xmla_test", BASESOFT.xmla.Test, {version: "1.0.0", build: "1"});
