# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.dashboard.controllers import DashboardWidgetCQStateController
from django.utils.translation import ugettext_lazy as _
from basesoft.util.ordered_dict import OrderedDict

class PublicationOverviewWidget(DashboardWidgetCQStateController):
    """
    Publication Overview Widget
    """
    label = _('Publication overview')
    name = 'iq_db_publish_overview_widget'
    icon = '16x16/categories/applications-accessories.png'
    category = 'IQuest'
    permissions = ['view_survey_publication', 'view_survey']
    classname = 'palette_group__menu--manager'

class SurveyManagerWidget(DashboardWidgetCQStateController):
    """
    Survey Manager Widget
    """
    label = _('Survey overview')
    name = 'iq_db_survey_manager'
    icon = '16x16/places/folder.png'
    category = 'IQuest'
    permissions = ['view_survey']
    classname = 'palette_group__menu--manager'

widgets_mapper = OrderedDict([
                 ('PublicationOverviewWidget', PublicationOverviewWidget),
                 ('SurveyManagerWidget', SurveyManagerWidget)
                 ])
