# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

base_modules = {

    # survey
    'iquest_survey': {
        'type': "js",
        'path': "widget/survey/survey/survey-min.js",
        'requires': [
            # important: only load modules which are required in _both_ response and compose mode
            'iquest_survey_scss', 'iq_compose',
            'iquest_survey_block', 'iquest_survey_column', 'iquest_survey_item',
            'iquest_survey_item_qa',

        ]
    },
    'iquest_survey_scss': {
        'type': "scss",
        'path': "widget/survey/survey/survey-min.scss"
    },

    # survey block
    # important: dont depend on block, column or item.. depend on survey instead
    'iquest_survey_block': {
        'type': "js",
        'path': "widget/survey/block/block-min.js",
        'requires': ['iquest_survey_block_css', 'iq_compose']
    },

    'iquest_survey_block_css': {
        'type': "css",
        'path': "widget/survey/block/block-min.css"
    },

    # survey column
    'iquest_survey_column': {
        'type': "js",
        'path': "widget/survey/column/column-min.js",
        'requires': ['iquest_survey_column_css', 'iq_compose']
    },
    'iquest_survey_column_css': {
        'type': "css",
        'path': "widget/survey/column/column-min.css"
    },

    # surey item
    'iquest_survey_item': {
        'type': "js",
        'path': "widget/survey/item/item-min.js",
        'requires': ['iquest_survey_item_scss', 'iq_compose']
    },

    'iquest_survey_item_scss': {
        'type': "scss",
        'path': "widget/survey/item/item-min.scss"
    },

    # survey item question
    'iquest_survey_item_qa': {
        'type': "js",
        'path': "widget/survey/item/item_qa-min.js",
        'requires': ['iquest_survey_item_qa_css', 'iq_compose']
    },

    'iquest_survey_item_qa_css': {
        'type': "css",
        'path': "widget/survey/item/item_qa-min.css"
    },

    # iquest_survey_item_qa (compose)
    'iquest_survey_item_qa_compose': {
        'type': "js",
        'path': "widget/survey/item/item_qa_compose-min.js",
        'requires': ['iquest_survey_item_qa', 'iquest_survey_item_qa_compose_scss']
    },

    'iquest_survey_item_qa_compose_scss': {
        'type': "scss",
        'path': "widget/survey/item/item_qa_compose-min.scss"
    },

    # iquest slider
    'iquest_slider': {
        'type': "js",
        'path': "widget/survey/item/iquest_slider-min.js",
        'requires': ['slider']
    },

    "iquest_survey_weight_factors": {
        'type': "js",
        'path': "widget/survey/item/qa_weight_factors-min.js",
        'requires': ['iq_form_manager', 'iq_container', 'iquest_survey_itemqa_filters_css']
    },

    # itemQA filters
    'iquest_survey_itemqa_filters': {
        'type': "js",
        'path': "widget/survey/item/qa_filters-min.js",
        'requires': ['iq_form_manager', 'iquest_survey_itemqa_filters_css']
    },

    'iquest_survey_itemqa_filters_css': {
        'type': "css",
        'path': "widget/survey/item/qa_filters-min.css"
    },


    # survey publication manager
    'iquest_publication': {
        'type': "js",
        'path': "widget/survey/survey/publication-min.js",
        'requires': ['iquest_publication_scss']
    },

    'iquest_publication_scss': {
        'type': "scss",
        'path': "widget/survey/survey/publication-min.scss"
    },

    'iquest_publication_manager': {
        'type': "js",
        'path': "widget/survey/survey/publication_manager-min.js",
        'requires': ['iq_manager', 'iquest_publication_manager_scss', 'iq_custom_query']
    },

    'iquest_survey_publication_wizard': {
        'type': "js",
        'path': "widget/survey/survey/survey_publication_wizard-min.js",
        'requires': ['compose_publication_wizard', 'iquest_publication']
    },

    'iquest_publication_manager_scss': {
        'type': "scss",
        'path': "widget/survey/survey/publication_manager-min.scss",
        'requires': ['iq_customdatatable_mixins_scss']
    },

    # surey variables
    'iquest_variable_manager': {
        'type': "js",
        'path': "widget/survey/survey/variable_manager-min.js",
        'requires': ['iq_manager', 'iquest_survey_variable_manager_css', 'iq_custom_query', 'iq_form_manager']
    },

    'iquest_survey_variable_manager_css': {
        'type': "css",
        'path': "widget/survey/survey/variable_manager-min.css"
    },

    'iquest_survey_manager': {
        'type': "js",
        'path': "widget/survey/survey/survey_manager-min.js",
        'requires': ['iq_manager', 'iq_custom_query', 'iquest_survey_manager_css']
    },

    'iquest_survey_manager_css': {
        'type': "css",
        'path': "widget/survey/survey/survey_manager-min.css",
    },

    'iquest_survey_preview': {
        'type': "js",
        'path': "widget/survey/survey/survey_preview-min.js",
        'requires': ['iq_manager', 'iq_form_manager', 'iquest_survey', 'iquest_response']
    },

    'iquest_survey_preview_css': {
        'type': "css",
        'path': "widget/survey/survey/survey_preview-min.css",
        'requires': []
    },

    'iq_db_publish_overview_widget': {
        'type': "js",
        'path': "widget/db_publish_overview_widget-min.js",
        'requires': ['iquest_publication_manager']
    },

    'iq_db_survey_manager': {
        'type': "js",
        'path': "widget/db_survey_manager-min.js",
        'requires': ['iquest_survey_manager']
    },

    'iquest_pool_manager': {
        'type': "js",
        'path': "widget/iquest_pool_manager-min.js",
        'requires': ['iq_manager', 'iq_custom_query']
    },

    'iquest_survey_print': {
        'type': 'js',
        'path': 'widget/survey/survey/survey_print-min.js',
        'requires': ['iquest_survey']
    },


}

def modules():
    dynamic_modules = {
        'iquest_survey_theme_debug': {
            'type': 'css',
            'path': 'widget/survey/survey/themes/debug-min.css'
        },
        'iquest_survey_theme_basesoft': {
            'type': 'css',
            'path': 'widget/survey/survey/themes/basesoft-min.css'
        },
        'iquest_survey_theme_tnt': {
            'type': 'css',
            'path': 'widget/survey/survey/themes/tnt-min.css'
        },
        'iquest_survey_theme_newcom': {
            'type': 'css',
            'path': 'widget/survey/survey/themes/newcom-min.css'
        },
    }

    # Merge base_modules into dynamic_modules
    # not the other way around cuz that would modify base_modules!
    dynamic_modules.update(base_modules)

    return dynamic_modules
