'''
Created on 6 Mar 2012

@author: martijn
'''
from iqportal.iquest.export.controllers import XlsExporter, SpssExporter
from iqportal.iquest.core.models import SurveyPublication
from django.http import HttpResponse

from datetime import datetime, date
import os

def export_xls(request, publication_id):
    """
    calls the iquest xls exporter and returns the excel file in the response
    """
    sa_session = request.Session()

    e = XlsExporter(sa_session=sa_session, account_id=request.session['user_id'], publication_id=publication_id)
    e.headers_mode = XlsExporter.HEADERS_MODE_3ROWS
    file_name = e.export()

    publication = sa_session.query(SurveyPublication).filter(SurveyPublication.id==publication_id).one()
    label = publication.label.replace(' ', '_');

    response = HttpResponse(open(file_name, 'r'), mimetype='application/excel')
    response['Content-Disposition'] = 'attachment; filename=%s_%s.xlsx' % (label, date.strftime(datetime.now(), '%d-%m-%y_%H-%I'))

    os.unlink(file_name)
    return response

def export_spss(request, publication_id):
    """
    calls the iquest xls exporter and returns the excel file in the response
    """
    sa_session = request.Session()

    e = SpssExporter(sa_session=sa_session, account_id=request.session['user_id'], publication_id=publication_id)
    file_name = e.export()

    publication = sa_session.query(SurveyPublication).filter(SurveyPublication.id==publication_id).one()
    label = publication.label.replace(' ', '_');

    response = HttpResponse(open(file_name, 'r'), mimetype='application/zip')
    response['Content-Disposition'] = 'attachment; filename=%s_%s.zip' % (label, date.strftime(datetime.now(), '%d-%m-%y_%H-%I'))

    os.unlink(file_name)
    return response

