# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iquest.compose.controllers import ItemPoolController
from iqportal.iquest.core.models import IQuestItemPoolItemQA, SurveyPublication
from django.utils.translation import ugettext as _
from iqportal.iquest.mobile.controllers import IQuestMobileController
from basesoft.web.core.exceptions import LoginRequiredException
from iqportal.iquest.compose.controllers import ComposeController

class MobileRpcHandler:

    def __init__(self, request, **kwargs):

        self.session = request.Session()
        try:
            self.account_id = request.session['user_id']
        except KeyError:
            raise LoginRequiredException()

        self.locale = request.session['config']['basesoft.web.contrib.locale']

        self.controller = IQuestMobileController(self.session, self.locale, self.account_id)

    def save_responses(self, publication_id, responses):
        return self.controller.save_responses(publication_id, responses)

    def get_offline_publications(self):
        return [{'id': p.id, 'name': p.label} for p in self.controller.get_offline_publications()]

    """
    def get_all_surveys(self):

        offline_ids = [s.id for s in self.controller.get_offline_surveys()]

        return [{
            'id': s.id,
            'name': s.name,
            'offline': (s.id in offline_ids)
        } for s in self.controller.get_all_surveys()]
    """

    def get_publication_survey_state(self, publication_id):

        # todo: check privs on this publication tru controller
        publication = self.session.query(SurveyPublication).get(publication_id)
        survey_id = publication.survey.id

        compose_controller = ComposeController(self.session, self.locale, self.account_id)
        return compose_controller.load_state(survey_id)


handlers = (MobileRpcHandler,)
