# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext as _

from iqportal.iquest.report.configurable_widgets.default_qa_item import DefaultQAItemWidget
from iqportal.iquest.report.configurable_widgets.multi_qa_item import MultiQAItemWidget
from iqportal.iquest.report.configurable_widgets.growth_item import GrowthItemWidget
from iqportal.iquest.report.configurable_widgets.qa_totals_item import QATotalsItemWidget
from iqportal.iquest.report.configurable_widgets.nps_item import NPSItemWidget
from iqportal.iquest.report.configurable_widgets.publication_statistics_item import PublicationStatisticsItemWidget

def sync(session):
    from iqportal.iqreport.core.models import IQReportGraphType

    graph_types = [{
        'module': 'iquest_graph_numericaltable',
        'name': 'iquest_numerical_table',
        'label': _('IQuest numerical response table'),
        'is_always_available': False
    },{
        'module': 'iquest_graph_table',
        'name': 'iquest_table',
        'label': _('IQuest response table'),
        'is_always_available': False
    }]
    current_types = [t.name for t in session.query(IQReportGraphType).all()]
    for gt in graph_types:
        if gt['name'] in current_types:
            continue

        type = IQReportGraphType()
        for attr, value in gt.iteritems():
            setattr(type, attr, value)
        session.add(type)

    session.flush()

configurable_widgets = (DefaultQAItemWidget, MultiQAItemWidget, GrowthItemWidget, QATotalsItemWidget, NPSItemWidget, PublicationStatisticsItemWidget)
