# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
from basesoft.scheduler.task import ScheduleTask
from iqportal.iquest.response.controllers import SurveyCloneResponseController


class CloneResponsesTask(ScheduleTask):
    INTERVAL = 0  # Don't run automatically.

    def execute(self):
        if not self.params.has_key('settings'):
            return

        settings = self.params['settings']
        self.logger.info('Clone responses task started with the following settings: %s' % settings)

        controller = SurveyCloneResponseController(self.sa_session)
        controller.task_clone_responses(**settings)


tasks = (CloneResponsesTask, )

