# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from django.utils.translation import ugettext_lazy as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon

class SAPProjectManagerIcon(IconBarIcon):
    """
    """

    id = 'icon-sap_project-manager'
    title = _('SAP Project manager')
    image = 'icons/project.png'
    icon_index = 80
    component = 'sap_project_manager'
    group = 'sap'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        """
        """
        controller.assert_permissions('view_sap_project')

def get_icons():
    return [SAPProjectManagerIcon(), ]
