# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.core.models import PrivilegeObject
from django.utils.translation import ugettext_lazy as _

class SAPProject(PrivilegeObject):
    """
    @DynamicAttrs
    """
    mark_as_deleted_permission = 'delete_sap_project'
    mark_as_archived_permission = 'update_sap_project'

    def get_group_object(self):
        return (SAPProjectGroup, 'project')

class SAPProjectGroup(object):
    """
    @DynamicAttrs
    """
    pass
class SAPComponentElementType(object):
    """
    @DynamicAttrs
    """
    pass
class SAPComponentElement(PrivilegeObject):
    """
    @DynamicAttrs
    """
    mark_as_deleted_permission = 'delete_sap_component_element'
    mark_as_archived_permission = 'update_sap_component_element'

    def get_group_object(self):
        return (SAPComponentElementGroup, 'component_element')

class SAPComponentElementGroup(object):
    """
    @DynamicAttrs
    """
    pass
class SAPProjectComponentElement(object):
    """
    @DynamicAttrs
    """
    pass
class SAPProjectPeriod(object):
    """
    @DynamicAttrs
    """
    pass
class SAPProjectEstimate(object):
    """
    @DynamicAttrs
    """
    cols_i18n = {
        'business_income': _("Business Income"),
        'percentage_income': _("Perc Income"),
        'percentage_expenses': _("Perc Expenses"),
        'part_of_income': _("Perc Of Income"),
        'part_of_expenses': _("Perc Of Expenses"),
        'improvement_income': _("Improvement Income"),
        'improvement_expenses': _("Improvement Expenses"),
        'income_ist': _("Income IST"),
        'expenses_ist': _("Expenses IST"),
        'income_soll': _("Income SOLL"),
        'expenses_soll': _("Expenses SOLL")
       }
class SAPProjectActual(object):
    """
    @DynamicAttrs
    """
    cols_i18n = {
        'income_now': _("Income Now"),
        'expenses_now': _("Expenses Now")
       }
