# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from django.utils.translation import ugettext as _

from basesoft.web.contrib.account.decorators import assert_user_logged_in
from basesoft.web.contrib.iconbar.models import IconBarIcon


class WEEEProductLevelManagerIcon(IconBarIcon):

    id = 'icon-weee-product-level-manager'
    title = _('WEEE product levels')
    icon_index = 70
    component = 'weee_product_level_manager'
    group = 'weee'
    colorname = 'iconbar-burnt-umber' # FIXME

    char_main = u'\uE800' # FIXME

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('view_weee_product_levels')

def get_icons():
    return [
        WEEEProductLevelManagerIcon()
    ]