# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.core.models import PrivilegeObject


class WEEEProductLevel(PrivilegeObject):
    """
    @DynamicAttrs
    """
    _name_property = 'name'

    def get_level_number(self):
        if self.parent_level is None:
            return self.position
        return '%s.%s' % (self.parent_level.level_number, self.position)

    level_number = property(get_level_number)

    def get_group_object(self):
        return (WEEEProductLevelGroup, 'product_level')

    def is_descendant_of(self, product_id):

        if self.parent_level is None:
            return False

        if self.parent_level.id == product_id:
            return True

        return self.parent_level.is_descendant_of(product_id)


    def __repr__(self):
        return '<WEEEProductLevel id=%d, label="%s">' % (self.id, self.label)


class WEEEProductLevelGroup(object):
    """
    @DynamicAttrs
    """
    pass


class WEEEProductLevelLocale(object):
    """
    @DynamicAttrs
    """
    pass
