# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.

from iqportal.iqube.core.reporters import ConfigurableWidgetReporter

class DutchAnnualReporter(ConfigurableWidgetReporter):

    def _get_applied_config(self, config, applied_config):
        columns, rows, slicers, mdx_with, split = ConfigurableWidgetReporter._get_applied_config(self, config, applied_config)

        times = []
        measure = '[Measures].[FloatData]'
        # if we get two years on columns we can calculate the growth
        if len(columns) == 2:
            for i in columns:
                if i['hierarchy_unique_name'] == '[Time]':
                    times.append(i['member_unique_name'])

        if len(times) == 2:
            columns.append(self._make_mdx('[Time].[Growth]'))

            mdx_with.append("""
                MEMBER [Time].[Growth] as 'IIF(IsEmpty((%s, %s)),
                    NULL,
                    ((%s, %s) - (%s, %s))/(%s, %s))',
                FORMAT_STRING='0.00%%'
            """ % (measure, times[0], measure, times[1], measure, times[0], measure, times[0]))

        return (columns, rows, slicers, mdx_with, split, )

reporters = (DutchAnnualReporter, )
